SystemOrganization addCategory: #'Idiom-Exercise'!

TestCase subclass: #IdiomTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Idiom-Exercise'!

!IdiomTest methodsFor: 'extras' stamp: 'EzequielBarrios 4/22/2013 21:29'!
ejecuta: aBlock enMenosDe: maxMiliseconds
	"comment stating purpose of message"

	| millisecondsBeforeRunning millisecondsAfterRunning |
	
	millisecondsBeforeRunning := Time millisecondClockValue.
	aBlock value.
	millisecondsAfterRunning := Time millisecondClockValue.
	
	^ self assert: millisecondsAfterRunning-millisecondsBeforeRunning < maxMiliseconds.! !

!IdiomTest methodsFor: 'extras' stamp: 'EzequielBarrios 4/22/2013 21:51'!
siAlEjecutar: aBlock ocurre: exceptionClass seManeja: anotherBlock
	"comment stating purpose of message"

	
	[ aBlock value .
	self fail ]
		on: exceptionClass 
		do: anotherBlock ! !

!IdiomTest methodsFor: 'testing' stamp: 'EzequielBarrios 4/22/2013 21:30'!
test01AddingCustomerShouldNotTakeMoreThan50Milliseconds

	| customerBook|
		
	customerBook := CustomerBook  new.
	

	self ejecuta:[customerBook addCustomerNamed: 'John Lennon'] enMenosDe: 50
	
! !

!IdiomTest methodsFor: 'testing' stamp: 'EzequielBarrios 4/22/2013 21:30'!
test02RemovingCustomerShouldNotTakeMoreThan100Milliseconds

	| customerBook johnLennon |
	
	customerBook := CustomerBook  new.
	johnLennon := 'John Lennon'.
	
	customerBook addCustomerNamed: johnLennon.

	self ejecuta:[customerBook removeCustomerNamed: johnLennon] enMenosDe: 100
	
! !

!IdiomTest methodsFor: 'testing' stamp: 'EzequielBarrios 4/22/2013 21:52'!
test03CanNotAddACustomerWithEmptyName 

	| customerBook |
			
	customerBook := CustomerBook new.
	
	self siAlEjecutar: [customerBook addCustomerNamed: ''] ocurre: Error seManeja: [ :anError | 
			self assert: anError messageText = CustomerBook customerCanNotBeEmptyErrorMessage.
			self assert: customerBook isEmpty ]! !

!IdiomTest methodsFor: 'testing' stamp: 'EzequielBarrios 4/22/2013 21:53'!
test04CanNotRemoveAndInvalidCustomer
	
	| customerBook johnLennon |
			
	customerBook := CustomerBook new.
	johnLennon := 'John Lennon'.
	customerBook addCustomerNamed: johnLennon.
	
	self siAlEjecutar: [customerBook removeCustomerNamed: 'Paul McCartney'] ocurre: NotFound seManeja:  [ :anError | 
			self assert: customerBook numberOfCustomers = 1.
			self assert: (customerBook includesCustomerNamed: johnLennon) ]
	! !

Object subclass: #CustomerBook
	instanceVariableNames: 'customers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Idiom-Exercise'!

!CustomerBook class methodsFor: 'error messages' stamp: 'HernanWilkinson 7/6/2011 17:57'!
customerAlreadyExistsErrorMessage

	^'Customer already exists'! !

!CustomerBook class methodsFor: 'error messages' stamp: 'HernanWilkinson 7/6/2011 17:53'!
customerCanNotBeEmptyErrorMessage

	^'Customer name cannot be empty'! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:42'!
addCustomerNamed: aName

	aName isEmpty ifTrue: [ self signalCustomerNameCannotBeEmpty ].
	(customers includes: aName) ifTrue: [ self signalCustomerAlreadyExists ].
	
	customers add: aName ! !

!CustomerBook methodsFor: 'testing' stamp: 'HernanWilkinson 7/6/2011 17:56'!
includesCustomerNamed: aName

	^customers includes: aName ! !

!CustomerBook methodsFor: 'initialization' stamp: 'HernanWilkinson 7/6/2011 17:42'!
initialize

	super initialize.
	customers := OrderedCollection new! !

!CustomerBook methodsFor: 'testing' stamp: 'HernanWilkinson 7/6/2011 17:48'!
isEmpty
	
	^customers isEmpty  ! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:56'!
numberOfCustomers
	
	^customers size! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:44'!
removeCustomerNamed: aName
 
	customers remove: aName ! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:52'!
signalCustomerAlreadyExists 

	self error: self class customerAlreadyExistsErrorMessage! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:51'!
signalCustomerNameCannotBeEmpty 

	self error: self class customerCanNotBeEmptyErrorMessage ! !
